<template>
  <base-modal
    :show="showDeleteTaskModal"
    @close-me="showDeleteTaskModal = false"
    @ok-button-clicked="deleteTask"
    @cancel-button-clicked="showDeleteTaskModal = false"
  >
    <template v-slot:body>
      <div>
        <span>Do you really want to remove </span>
        <b>{{ taskNameToDelete }}</b>
        <span> ?</span>
      </div>
    </template>
  </base-modal>
  <base-modal
    :show="showAddTaskModal"
    @close-me="showAddTaskModal = false"
    @ok-button-clicked="addTask"
    @cancel-button-clicked="showAddTaskModal = false"
  >
    <template v-slot:body>
      <base-control
        :settings="{
          type: 'select',
          label: 'Select Task',
          options: tasksOptions,
        }"
        @changed="onChanged"
      />
    </template>
  </base-modal>
  <base-modal
    :show="showDeleteModal"
    :cancelButtonDisplay="cancelButtonDisplay"
    :okButtonLabel="okButtonLabel"
    @close-me="showDeleteModal = false"
    @ok-button-clicked="deleteRecord"
    @cancel-button-clicked="showDeleteModal = false"
  >
    <template v-slot:body>
      <div v-if="!totalTasks > 0">
        <span>Do you really want to delete a record of </span>
        <b>{{ person.first + " " + person.last }}</b>
        <span> ?</span>
      </div>
      <div v-else>
        <span>You are not allowed to delete a person with assigned tasks</span>
      </div>
    </template></base-modal
  >
  <base-page title="Person details" :loading="loading">
    <template v-slot:top-right> </template>
    <template v-slot:content>
      <h2>{{ person.first + " " + person.last }}</h2>
      <ul>
        <li>Position: {{ person.position }}</li>
        <li>Completed tasks: {{ completedTasks }}</li>
        <li>Total tasks: {{ totalTasks }}</li>
        <li v-if="tasks.length">
          <ul class="task-ul">
            <li class="task-li" v-for="task in tasks">
              {{ task.task }}
              <base-button
                class="task-delete-btn"
                @clicked="onDeleteTaskClicked(task.id)"
                label="x"
              ></base-button>
            </li>
          </ul>
        </li>
      </ul>
    </template>
    <template v-slot:footer>
      <base-button @clicked="onAddTaskClicked" label="Add Task" />
      <base-button @clicked="onEditClicked" label="Edit person" />
      <base-button @clicked="onDeleteClicked" label="Delete person" />
    </template>
  </base-page>
</template>

<script>
import BaseControl from "../../components/BaseControl.vue";
import BaseModal from "../../components/BaseModal.vue";
import BaseButton from "../../components/BaseButton.vue";
import BasePage from "../../components/BasePage.vue";
import db from "../../utilities/db";
export default {
  name: "PersonDetail",
  data() {
    return {
      person: {},
      loading: true,
      tasks: [],
      showDeleteModal: false,
      showAddTaskModal: false,
      showDeleteTaskModal: false,
      allTasks: [],
      taskToAdd: "",
      taskToDelete: "",
    };
  },
  methods: {
    onAddTaskClicked() {
      db.get("js4tasks").then((data) => {
        this.allTasks = data;
        this.taskToAdd = "";
        this.showAddTaskModal = true;
      });
    },
    onDeleteTaskClicked(taskid) {
      this.taskToDelete = taskid;
      this.showDeleteTaskModal = true;
    },
    deleteTask() {
      db.delete("js4personstasks/" + this.taskToDelete).then(() => {
        db.get("js4personstasks?personid=" + this.$route.params.id).then(
          (data) => {
            this.tasks = data;
            this.showDeleteTaskModal = false;
          }
        );
      });
    },
    addTask() {
      if (this.taskToAdd) {
        db.post("js4personstasks", {
          personid: this.person.id,
          taskid: this.taskToAdd,
        }).then(() => {
          db.get("js4personstasks?personid=" + this.$route.params.id).then(
            (data) => {
              this.tasks = data;
              this.showAddTaskModal = false;
            }
          );
        });
      }
    },
    onChanged(payload) {
      this.taskToAdd = payload.value;
    },
    onAddPersonClicked() {
      console.log(this.tasks);
    },
    onDeleteClicked() {
      this.showDeleteModal = true;
    },
    deleteRecord() {
      if (!this.totalTasks) {
        db.delete("js4persons/" + this.person.id).then(() => {
          this.$router.replace("/persons");
        });
      } else {
        this.showDeleteModal = false;
      }
    },
    onEditClicked() {
      this.$router.push("/personform/" + this.$route.params.id);
    },
  },
  created() {
    const promises = [
      db.get("js4persons/" + this.$route.params.id).then((data) => {
        this.person = data;
      }),
      db
        .get("js4personstasks?personid=" + this.$route.params.id)
        .then((data) => {
          this.tasks = data;
        }),
    ];
    Promise.all(promises).then(() => {
      this.loading = false;
    });
  },
  computed: {
    taskNameToDelete() {
      if (!this.taskToDelete) {
        return "";
      }
      return this.tasks.find((item) => item.id === this.taskToDelete).task;
    },
    tasksOptions() {
      return this.allTasks
        .filter((item) => {
          return !this.tasks.some((task) => task.taskid === item.id);
        })
        .map((item) => {
          return {
            label: item.task,
            value: item.id,
          };
        });
    },
    totalTasks() {
      return this.tasks.length;
    },
    completedTasks() {
      return this.tasks.filter((task) => task.completed).length;
    },
    cancelButtonDisplay() {
      return !this.totalTasks > 0;
    },
    okButtonLabel() {
      return this.totalTasks > 0 ? "OK" : "delete";
    },
  },
  components: { BasePage, BaseButton, BaseModal, BaseControl },
};
</script>

<style scoped>
.task-ul {
  width: 80%;
  margin: auto;
}
.task-li {
  display: flex;
  align-items: center;
}
</style>
